var _MT_VcMobileObject = false;

function _MT_VcMobileDeviceDetectionLoaded(p)
{
	if (typeof window._vc_mobile_run != 'undefined')
		return;
	window._vc_mobile_run = true;

	var props = _mt_vc_props[ p ] || {};
	var adv = _mt_vc_adv[ p ] || [];

	window._MT_VcMobileObject = new _MT_VcMobile(adv);
	if (props != null) {
		if (props.link_tags != null)
			for (var i in props.link_tags)
				props.use_tags[ props.link_tags[ i ] ] = 1;
		if (props.inline_count_max != null)
			_MT_VcMobileObject.params.inline_limit = props.inline_count_max;

		if (props.autostart_video != null)
			_MT_VcMobileObject.params.autostart_video = props.autostart_video;
		if (props.w_style != null)
			_MT_VcMobileObject.w_style = props.w_style;
		if (adv.length > 0 && adv[ 0 ].lt && adv[ 0 ].lt == "any")
			_MT_VcMobileObject.params.inline_limit = 0;
		if (adv.length > 0 && adv[ 0 ].lm && adv[ 0 ].lm == "dummy")
			_MT_VcMobileObject.params.link_dummy = true;

		if (props.use_tags != null)
			for (var i in props.use_tags)
				_MT_VcMobileObject.skip_tags[ i.toUpperCase() ] = props.use_tags[ i ] == 1 ? 0 : 1;
		if (props.use_classes != null)
			for (var i in props.use_classes)
				_MT_VcMobileObject.skip_classes[ i ] = props.use_classes[ i ] == 1 ? 0 : 1;
		if (props.use_ids != null)
			for (var i in props.use_ids)
				_MT_VcMobileObject.skip_ids[ i ] = props.use_ids[ i ] == 1 ? 0 : 1;
	}
	_MT_VcMobileObject.run();
}

function _MT_VcMobileStylesLoaded(p)
{
	_MT_jsLoadDelayed(
		_mt_proto +'//videoclick.ru/storage/contribs/device-detection.js',
		function() { _MT_VcMobileDeviceDetectionLoaded(p) },
		'_MT_DEVICE_DETECTION'
	);
}

function _MT_VcMobileCustomStylesLoaded(p)
{
	var adv = _mt_vc_adv[ p ] || [];
	if (adv[ 0 ] && adv[ 0 ].styles_url) {
		// load custom styles
		var css = document.createElement('link');
		css.setAttribute('rel', 'stylesheet');
		css.setAttribute('type', 'text/css');
		css.setAttribute('href', adv[ 0 ].styles_url);
		css.onload = css.onreadystatechange = function() { _MT_VcMobileStylesLoaded(p) }
		document.getElementsByTagName('head')[ 0 ].appendChild(css);
	} else
		_MT_VcMobileStylesLoaded(p);
}

function _MT_VcMobileCoreLoaded(p)
{
	// load custom styles
	var css = document.createElement('link');
	css.setAttribute('rel', 'stylesheet');
	css.setAttribute('type', 'text/css');
	css.setAttribute('href', _mt_proto +'//videoclick.ru/storage/vc-mobile-format.css');
	css.onload = css.onreadystatechange = function() { _MT_VcMobileCustomStylesLoaded(p) }
	document.getElementsByTagName('head')[ 0 ].appendChild(css);
}

function _MT_VcMobileRun(p)
{
	// Request core
	_MT_jsLoadDelayed(
		_mt_proto +'//videoclick.ru/core/code?pid='+p+'&rid='+_mt_rnd+'&rl='+_mt_referrer+'&ll='+_mt_location,
		function() { _MT_VcMobileCoreLoaded(p) },
		'_MT_VC_CODE_'
	);
}

function _MT_VcMobileEventsHandler(ev, oid) {
	var banner = _MT_VcMobileObject.adv[ oid ];
	switch (ev) {
		case 'click':
		case 'close':
			break;
		case 'ready':
			if (banner && ! banner.trace) {
				if (banner.trace_url)
					_MT_VcMobileObject.cacheFile(banner.trace_url+'&ul='+_MT_VcMobileObject.location);
				if (banner.trace_url2 && banner.trace_url2.length > 0)
					_MT_VcMobileObject.cacheFile(banner.trace_url2);
				banner.trace = true;
			}
			break;
		case 'quarter':
			if (banner && banner.evq)
				_MT_VcMobileObject.cacheFile(banner.evq);
			if (banner && banner.trace_evq)
				_MT_VcMobileObject.cacheFile(banner.trace_evq);
			break;
		case 'half':
			if (banner && banner.evh)
				_MT_VcMobileObject.cacheFile(banner.evh);
			if (banner && banner.trace_evh)
				_MT_VcMobileObject.cacheFile(banner.trace_evh);
			break;
		case 'threequarters':
			if (banner && banner.evtq)
				_MT_VcMobileObject.cacheFile(banner.evtq);
			if (banner && banner.trace_evtq)
				_MT_VcMobileObject.cacheFile(banner.trace_evtq);
			break;
		case 'complete':
			if (banner && banner.evc)
				_MT_VcMobileObject.cacheFile(banner.evc);
			if (banner && banner.trace_evc)
				_MT_VcMobileObject.cacheFile(banner.trace_evc);
			break;
	}
}

// Определение размера окна
function _MT_getPageSize(){
	var xScroll, yScroll, pageWidth, pageHeight, windowWidth, windowHeight;

	if (window.innerHeight && window.scrollMaxY) {
		xScroll = document.body.scrollWidth;
		yScroll = window.innerHeight + window.scrollMaxY;
	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
		xScroll = document.body.scrollWidth;
		yScroll = document.body.scrollHeight;
	} else if (document.documentElement && document.documentElement.scrollHeight > document.documentElement.offsetHeight){ // Explorer 6 strict mode
		xScroll = document.documentElement.scrollWidth;
		yScroll = document.documentElement.scrollHeight;
	} else { // Explorer Mac, Mozilla, Safari
		xScroll = document.body.offsetWidth;
		yScroll = document.body.offsetHeight;
	}

	if (self.innerHeight) { // Explorer
		windowWidth = self.innerWidth;
		windowHeight = self.innerHeight;
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
		windowWidth = document.documentElement.clientWidth;
		windowHeight = document.documentElement.clientHeight;
	} else if (document.body) { // страрые Explorers
		windowWidth = document.body.clientWidth;
		windowHeight = document.body.clientHeight;
	}

	// для небольших страниц с общей высотой менее высоты окна просмотра
	if(yScroll < windowHeight){
		pageHeight = windowHeight;
	} else {
		pageHeight = yScroll;
	}

	// для небольших страниц с общей шириной менее ширины окна просмотра
	if(xScroll < windowWidth){
		pageWidth = windowWidth;
	} else {
		pageWidth = xScroll;
	}

	return [pageWidth,pageHeight,windowWidth,windowHeight];
}

// Определение позиции элемента относительно страницы
function _MT_getElementPosition(elem)
{
	var w = elem.offsetWidth;
	var h = elem.offsetHeight;

	var l = 0;
	var t = 0;

	while (elem) {
		l += elem.offsetLeft;
		t += elem.offsetTop;
		elem = elem.offsetParent;
	}

	return {"left":l, "top":t, "width": w, "height":h};
}

function _MT_getPageScroll()
{
	var html = document.documentElement;
	var body = document.body;

	var top = html.scrollTop || body && body.scrollTop || 0;
	top -= html.clientTop;

	var left = html.scrollLeft || body && body.scrollLeft || 0;
	left -= html.clientLeft;

	return { 'top': top, 'left': left };
}

function _MT_getPageSizeCross()  {
	var w=document.documentElement; var d=document.body;
	var tww = document.compatMode=='CSS1Compat' && !window.opera?w.clientWidth:d.clientWidth;
	var twh = document.compatMode=='CSS1Compat' && !window.opera?w.clientHeight:d.clientHeight;
	var sl = (window.scrollX)?window.scrollX:(w.scrollLeft)?w.scrollLeft:d.scrollLeft;
    var st = (window.scrollY)?window.scrollY:(w.scrollTop)?w.scrollTop:d.scrollTop;
	var wW1 = (window.innerHeight && window.scrollMaxY)?d.scrollWidth:(d.scrollHeight > d.offsetHeight)?d.scrollWidth:(w && w.scrollHeight > w.offsetHeight)?w.scrollWidth:d.offsetWidth;
	var wH1 = (window.innerHeight && window.scrollMaxY)?d.scrollHeight:(d.scrollHeight > d.offsetHeight)?d.scrollHeight:(w && w.scrollHeight > w.offsetHeight)?w.scrollHeight:d.offsetHeight;
	var wW2 = (self.innerHeight)?self.innerWidth:(w && w.clientHeight)?w.clientWidth:d.clientWidth; var pW = (wW1 < wW2)?wW2:wW1;
	var wH2 = (self.innerHeight)?self.innerHeight:(w && w.clientHeight)?w.clientHeight:d.clientHeight; var pH = (wH1 < wH2)?wH2:wH1;
	pW = (!-[1,])?pW:Math.max(w.scrollWidth, w.clientWidth, d.scrollWidth, d.offsetWidth);
	pH = (!-[1,])?pH:Math.max(w.scrollHeight, w.clientHeight, d.scrollHeight, d.offsetHeight);
	if (window.opera){ tww = (d.scrollWidth==d.clientWidth)?w.clientWidth:tww; twh = (d.scrollHeight==d.clientHeight)?w.clientHeight:twh;}
	return { 
		winWidth:tww, 
		winHeight: twh, 
		winScrollLeft: sl, 
		winScrollTop: st, 
		pageWidth: pW, 
		pageHeight: pH
	} 
}

// MT Advanced Word
var bannerOpen = false;

function _MT_VcMobileWord(o)
{
	var _MT_link = o.link;
	var _MT_funcName = o.funcName;
	var _MT_objectId = o.objectId;
	var _MT_bannerId = o.bannerId;
	var _MT_wordId = o.wordId;

	// Путь ко всем материалам
	var _MT_assetsPath = o.assetsPath;
	var _MT_container = o.container;
	var _MT_openDelay = o.openDelay;
	
	var el = document.getElementById(_MT_wordId);
	var firstTime;
	var wordOpen;

	function init()
	{
		firstTime = true;
		wordOpen = false;
		window.addEventListener('scroll', checkVisible, false);
		window.addEventListener('resize', checkVisible, false);
		
		addEvents();
	}
	
	// События
	function addEvents()
	{
		firstTime = true;
		var count = 0;
		el.addEventListener('mouseover', checkVisible, false);
	}

	// Проверка объекта в видимой области
	function checkVisible()
	{
		var pos = _MT_getElementPosition(el);
		var scroll = _MT_getPageScroll();
		var page = _MT_getPageSize();
	
		var posTop = pos.top;
		var scrollTop = scroll.top;
		var elHeight = pos.height;
		var pageHeight = page[1];
		var windowHeight = page[3];

		if ((scrollTop <= posTop && (elHeight + posTop) < (scrollTop + windowHeight)) && (((scrollTop + windowHeight)+10) >=pageHeight)) {
			if (firstTime == true) {
				firstTime = false;
				wordOpen = true;
				showWord();
			}
		} else if ((scrollTop <= (posTop-(windowHeight/4)) && scrollTop >= (posTop-(windowHeight/1.6)))) {
			if (firstTime == true) {
				firstTime = false;
				wordOpen = true;
				showWord();
			}
		} else if ((scrollTop >= (posTop-(windowHeight)) && scrollTop >= (posTop-(windowHeight/2)))) {
			if (firstTime == true) {
				firstTime = false;
				wordOpen = true;
				showWord();
			}
		} else {
			if (wordOpen == true) {
				wordOpen = false;
				hideWord();
			}
		}
	}

	// Показ слова
	function showWord()
	{
		el.className = 'mtWordActive';
		wordEvents();
	}

	// Закрытие слова и перезапуск событий
	function hideWord()
	{
		el.className = 'mtWord';
		setTimeout(function() {
			removeWordEvents();
			addEvents();
		}, 100);
	}

	// События для вспылвающего слова
	function wordEvents() {
		el.addEventListener('click', goTo, false);
	}

	function removeWordEvents() {
		el.removeEventListener('click', goTo, false);
	}

	// Запуск баннера
	function goTo()
	{
		var params = {
			'assetsPath': _MT_assetsPath,
			'link': _MT_link,
			'bannerId': _MT_bannerId,
			'openDelay': _MT_openDelay,
			'statScript': "_MT_VcMobileEventsHandler('{event}'," + _MT_objectId + ")"
		};
		window[ _MT_funcName ](params);
	}

	init();
}

function _MT_VcMobile(adv) {
	this.adv = adv;
	this.objects = [];
	this.params = {
		'inline_limit'   : 10,
		'info_url'       : 'http://videoclick.ru/',
		'show_timeout'   : 100,
		'hide_timeout'   : 700,
		'autostart_video': true,
		'link_dummy'     : false
	};
	this.skip_tags = {
		'SCRIPT': 1,
		'NOSCRIPT': 1,
		'STYLE': 1,
		'H1': 1,
		'H2': 1,
		'H3': 1,
		'H4': 1,
		'H5': 1,
		'H6': 1,
		'BIG': 1,
		'A': 1,
		'TH': 1,
		'FIELDSET': 1,
		'TEXTAREA': 1,
		'SELECT': 1,
		'LEGEND': 1,
		'ACRONYM': 1,
		'ADDRESS': 1,
		'LABEL': 1
	};
	this.skip_classes = {
		'_reachbanner_': 0,
		'_noreachbanner_': 1
	};
	this.skip_ids = {
		'ya_partner': 1,
		'y5_direct': 1
	};
	this.w_bounds = '(^|$|[^0-9a-zA-Zа-яА-ЯёЁіІїЇ_])';
	this.neg = [];
	this.negr = [];
	this.blocks = [];
	this.words = [];
	this.w_style = {
		'cursor'            : 'pointer',
		'color'             : '#009900',
		'textDecoration'    : 'none',
		'borderStyle'       : 'solid',
		'borderWidth'       : '0 0 1px 0'
	};
	this.dist_min = 150;
	this.dist_max = 400;
	this.dist2_min = 1000;
	this.dist2_max = 1250;
	this.location = escape(window.location.href);

	this.run = function() {
		var n = document.getElementsByTagName('body')[0];
		this.prepareRegexp();
		this.scanBlocks(n, this.isScanNode(n));
		if (this.scanNeg())
			return;
		this.scanWords();
		this.linkWords();
		this.sendInlined();
	}

	this.prepareRegexp = function() {
		var i, j, n, w;
		for (i = 0; i < this.adv.length; i++) {
			this.adv[i].words = this.adv[i].keyword.split(";");
			this.adv[i].words.sort(function(){return (Math.round(Math.random())-0.5);});
			this.adv[i].regexp = new Array();
			this.adv[i].negr = new Array();
			this.adv[i].prefs = new Array();
			this.adv[i].inlined = new Array();
			this.adv[i].word = new Array();
			this.adv[i].icon = new Array();
			this.adv[i].wt = new Array();
			this.adv[i].skip = false;
			this.adv[i].wid = 0;
			for (j = 0; j < this.adv[i].words.length; j++) {
				w = this.adv[i].words[j];
				if (w.substr(w.length - 1, 1) == '*') {
					w = w.substr(0, w.length - 1) + '[0-9a-zA-Zа-яА-ЯёЁіІїЇ_]+';
				}
				this.adv[i].regexp[j] = new RegExp(this.w_bounds + '(' + w + ')' + this.w_bounds, 'ig');
				this.adv[i].inlined[j] = false;
			}
			n = this.adv[i].negative.split(";");
			for (j = 0; j < n.length; j++) {
				if (n[j] != "") {
					this.adv[i].negr.push(new RegExp(n[j], 'ig'));
				}
			}
			if (this.adv[i].prefixes) {
				n = this.adv[i].prefixes.split(";");
				for (j = 0; j < n.length; j++) {
					if (n[j] != "") {
						this.adv[i].prefs.push(new RegExp(n[j], 'ig'));
					}
				}
			}
		}
		for (i = 0; i < this.neg.length; i++) {
			this.negr[i]= new RegExp(this.neg[i],'ig');
		}
	}

	this.scanBlocks = function(n, s) {
		if (n.nodeType == 3 /* TEXT_NODE */) {
			if (s == false)
				return;
			if (n.data.replace(/\s+/g, ""))
				this.blocks.push(n);
		} else if (n.nodeType == 1 /* ELEMENT_NODE */) {
			for (var i = n.firstChild; i != null; i = i.nextSibling) {
				var scanNode = this.isScanNode(i);
				if (typeof scanNode == 'undefined')
					this.scanBlocks(i, s);
				else
					this.scanBlocks(i, scanNode);
			}
		}
	}

	this.isScanNode = function(n) {
		if (typeof n.getAttribute != 'undefined')
			var nodeId = n.getAttribute('id');
		else
			var nodeId = n.id;

		if (typeof n.style != 'undefined')
			if (n.style.display == 'none')
				return false;

		if (typeof nodeId == 'string' && n.id != '')
			for (var k in this.skip_ids)
				if (nodeId.indexOf(k) != -1)
					return this.skip_ids[ k ] == 0;

		var skipTagResolution = this.skip_tags[ n.nodeName.toUpperCase() ];
		if (typeof skipTagResolution != 'undefined')
			return skipTagResolution == 0;

		if (n.className && n.className.indexOf)
			for (var k in this.skip_classes)
				if (n.className.indexOf(k) != -1)
					return this.skip_classes[ k ] == 0;
	}

	this.scanNeg = function() {
		var i, j, k, r, n;
		for (k = 0; k < this.blocks.length; k++) {
			n = this.blocks[k];
			for (i = 0; i < this.negr.length; i++) {
				r = this.negr[i].exec(n.data);
				if (r != null) {
					return true;
				}
			}
			for (i = 0; i < this.adv.length; i++) {
				for (j = 0; j < this.adv[i].negr.length; j++) {
					r = this.adv[i].negr[j].exec(n.data);
					if (r != null) {
						this.adv[i].skip = true;
						break;
					}
				}
			}
		}
		return false;
	}

	this.negPrefix = function(txt, pos, prefs) {
		var i, pb, pe, len, pref;
		if (pos == 0) {
			return false;
		}
		for (pe = pos - 1; pe > 0; pe--) {
			if (txt.substr(pe, 1).search(/[0-9a-zA-Zа-яА-ЯёЁіІїЇ_]/i) >= 0) {
				break;
			}
		}
		if (pe > 0) {
			pb = -1;
			for (i = pe; i >= 0; i--) {
				if (txt.substr(i, 1).search(/[^0-9a-zA-Zа-яА-ЯёЁіІїЇ_]/i) >= 0) {
					pb = i;
					break;
				}
			}
			if (pb == -1) {
				pref = txt.substr(0, pe + 1);
			} else {
				pref = txt.substr(pb + 1, pe - pb);
			}
			len = prefs.length;
			for (i = 0; i < len; i++) {
				if (pref.search(prefs[i]) != -1) {
					return true;
				}
			}
		}
		return false;
	}

	this.scanWords = function() {
		var i, j, m, n, k, r, mi, mv, n, nn, p, w, wi, wm, wp, ws, ws2, words = [], stat = {}, res = [];
		p = 0;
		for (k = 0; k < this.blocks.length; k++) {
			n = this.blocks[ k ];
			for (i = 0; i < this.adv.length; i++) {
				if (this.adv[ i ].skip)
					continue;
				for (j = 0; j < this.adv[ i ].words.length; ++j) {
					r = this.adv[ i ].regexp[ j ].exec(n.data);
					if (r != null) {
						if (this.adv[ i ].prefs.length && this.negPrefix(n.data, r.index + r[ 1 ].length, this.adv[ i ].prefs))
							continue;
						w = {};
						w.aid = i;
						w.wid = this.adv[ i ].wid++;
						w.nid = k;
						w.pos = r.index + r[ 1 ].length;
						w.gpos = p + w.pos;
						w.len = r[ 2 ].length;
						w.word = n.data.substr(w.pos, w.len);
						words.push(w);
					}
				}
			}
			p += n.data.length;
		}
		words.sort(function(a,b){ return a.gpos-b.gpos });
		if (this.params.link_dummy) {
			res = [];
			for (i = 0; i < words.length; ++i) {
				if (!(i > 0 && words[ i ].gpos == words[ i - 1 ].gpos))
					res.push(words[ i ]);
			}
		} else {
			for (i = 0; i < this.adv.length; ++i)
				stat[ i ] = 0;
			j = 0;
			for (i = 0; i < words.length; ++i) {
				if (i > 0 && words[ i ].gpos == words[ i - 1 ].gpos) {
					res[ j - 1 ] .push(words[ i ])
				} else {
					w = [];
					w.push(words[ i ]);
					res[ j++ ] = w;
				}
			}
			words = res;
			res = [];
			if (words.length > 0) {
				n = 0;
				res[ n++ ] = words[ 0 ][ 0 ];
				++stat[ res[ 0 ].aid ];
				for (i = 1; i < words.length; ++i) {
					ws = words[ i ];
					wp = res[ n - 1 ];
					if (n > 4) {
						if (ws[ 0 ].gpos - wp.gpos < this.dist2_max)
							continue
					} else if (ws[ 0 ].gpos - wp.gpos < this.dist_max)
						continue
					wi = i;
					wm = 0;
					for (j = wi; j > 0; j--) {
						ws2 = words[ j ];
						if (n > 4) {
							if (ws2[ 0 ].gpos - wp.gpos < this.dist2_min)
								break
						} else if (ws2[ 0 ].gpos - wp.gpos < this.dist_min) {
							break
						}
						for (m = 0; m < ws2.length; m++) {
							if (stat[ ws2[ m ].aid ] < stat[ words[ wi ][ wm ].aid] ) {
								wi = j;
								wm = m;
							}
						}
					}
					res[ n++ ] = words[ wi ][ wm ];
					stat[ words[ wi ][ wm ].aid ]++;
				}
			}
		}
		if (res.length) {
			if (this.params.inline_limit)
				res = res.slice(0, this.params.inline_limit);
			this.inlineWords(res);
		}
	}

	this.inlineWords = function(res) {
		var i, j, w, p, nd = {}, nn, pn, b, bt, a, k, im, d;
		for (i = 0; i < res.length; ++i) {
			w = res[ i ];
			if (typeof nd[ w.nid ] == 'undefined')
				nd[ w.nid ] = [];
			nd[ w.nid ].push(w)
		}
		for (i in nd) {
			p = 0;
			nn = [];
			b = this.blocks[ i ];
			bt = b.data;
			for (j = 0; j < nd[ i ].length; ++j) {
				w = nd[ i ][ j ];
				var ad = this.adv[ w.aid ];
				var wordId = '_MT_Word_'  + w.aid + '_' + w.wid;
				var bannerId = '_MT_Banner' + w.aid;

				nn.push(document.createTextNode(bt.substr(p, w.pos - p)));
				a = document.createElement("A");
				a.href = 'javascript://';
				a.id = wordId;
				a.className = 'mtWord';
				a.appendChild(document.createTextNode(bt.substr(w.pos, w.len)));

 				ad.wordsToLink = ad.wordsToLink || [];
 				ad.wordsToLink.push({ bannerId : bannerId, wordId : wordId, objectId : w.aid });

				if (w.len < 32)
					this.adv[ w.aid ].wt.push(this.encode(bt.substr(w.pos, w.len).toLowerCase()));

				nn.push(a);
				this.adv[ w.aid ].word[ w.wid ] = a;
				p = w.pos + w.len;
			}
			if (bt.length > p)
				nn.push(document.createTextNode(bt.substr(p)));
			pn = b.parentNode;
			if (pn) {
				while (nn.length > 0)
					b=pn.insertBefore(nn.pop(), b);
				pn.removeChild(this.blocks[ i ]);
			}
		}
	}

	this.linkWords = function() {
		for (i in this.adv) {
			var ad = this.adv[ i ];
			if (typeof ad.wordsToLink == 'undefined')
				continue;
			_MT_jsLoadDelayed(ad.script_url, new this.linkBannerWords(this, i));
		}
	}

	this.linkBannerWords = function(o, aid) {
		var ad = o.adv[ aid ];
		var sPos = ad.script_url.lastIndexOf('/') + 1;
		var assetsPath = ad.script_url.substr(0, sPos);
		var scriptName = ad.script_url.substr(sPos);
		var funcName = scriptName.substr(0, scriptName.lastIndexOf('.'));

		for (var w = 0; w < ad.wordsToLink.length; ++w) {
			var wo = ad.wordsToLink[ w ];
			o.objects.push(new _MT_VcMobileWord({
				'objectId': wo.objectId,
				'wordId': wo.wordId,
				'bannerId': wo.bannerId,
				'funcName': funcName,
				'assetsPath': assetsPath,
				'link': ad.click_url,
				'openDelay': ad.open_delay
			}));
		}
	}

	this.sendInlined = function() {
		for (var i = 0; i < this.adv.length; ++i)
			if (this.adv[ i ].wt.length > 0 && this.adv[ i ].link)
				this.cacheFile(this.adv[ i ].link + this.adv[ i ].wt.join(';') + '&ul=' + this.location);
	}

	this.encode = function(s) {
		var c,n,t="";
		for (n = 0; n < s.length; ++n) {
			c = s.charCodeAt(n);
			if (c < 128) {
				t+=String.fromCharCode(c);
			} else if ((c>127) && (c<2048)) {
				t+='%'+((c >> 6) | 192).toString(16).toUpperCase();
				t+='%'+((c & 63) | 128).toString(16).toUpperCase();
			} else {
				t+='%'+((c >> 12) | 224).toString(16).toUpperCase();
				t+='%'+(((c >> 6) & 63) | 128).toString(16).toUpperCase();
				t+='%'+((c & 63) | 128).toString(16).toUpperCase();
			}
		}
		return t;
	}

	this.cacheFile = function(u) {
		(new Image(10, 10)).src = u.replace("{rid}", Math.random());
	}
}
